<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
	<NuxtLayout name="default">
		<div>

			<!-- sidebar navigation teleported to template -->
			<SidebarNav :nav="navItems" :title="'Domains'" />

			<TopbarTopBar :breadcrumb="breadcrumb" @edit-click="openEditModal" @delete-click="deleteDomain" />
			<div class="detail-header">
				<div class="row">
					<div class="col-xl-12">
						<div class="title">
							<h2>{{ domainsDetails?.name }}</h2>
							<span class="type-domains">Domain</span>
						</div>
					</div>
				</div>
			</div>
			<div class="detail-body">
				<div class="row">
					<div class="col-xl-3">
						<div class="about">
							<div class="info">
								<h3>Creation Date</h3>
								<p>17:14:12 <br> 25 Jan 2024</p>
							</div>
							<div class="info">
								<h3>Last Edition</h3>
								<p>17:14:12 <br> 25 Jan 2024</p>
							</div>
						</div>
						<div class="info user">
							<h3>Owner</h3>
							<UserProfile />
						</div>
						<div class="info user">
							<h3>Shared with</h3>
							<UsersSelectionList />
						</div>
					</div>
					<div class="col-xl-8 offset-xl-1">
						<div class="row">
							<div class="col-xl-9">
								<EditableTextBox title="Full description" :text="domainsDetails?.description || ''" />
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="detail-tab">
				<DomainDetailTabs />
			</div>
			<div class="container">
				<div class="offset-xl-1 col-xl-10 mt-160">
					<BannersBannerCta :banners="BannerCta" />
				</div>
			</div>
		</div> 
		<ClientOnly>
            <Teleport to="#modals-container">
                <ModalsCreateDomain v-if="showCreateDomainModal" @toggle="close" :edit="true" :data="domainsDetails" @refresh-data="fetchData" />
				<ModalsModalDelete v-if="showDeleteDomainModal" @toggle="closeDelete" :value="domainsDetails?.name" type="Domain" />
            </Teleport>
        </ClientOnly>
	</NuxtLayout>
</template>
<script setup lang="ts">
import DomainDetailTabs from '~/components/tabs/DomainDetailTabs.vue';
import type NavItemI from '~/interfaces/navItem';
import type sliderItemI from '~/interfaces/sliderItem';
import slide1 from '@/assets/images/slide1.png';


const route = useRoute();

/** DOMAINS - get domain detail **/

const domainsDetails = ref<any>(null);

// Define Breadcrumb interface
interface BreadcrumbI {
    title: string;
    link: string;
}

const breadcrumb = ref<any>([]);

async function fetchData() {
  if (route.params.name) {
    try {
      const response = await useFetchAuth(`/domains/${route.params.name}`);
      domainsDetails.value = response || {};
	  breadcrumb.value = [
		{ title: 'Domains', link: '/domains' },
		{ title: domainsDetails.value?.name, link: '#' },
	  ]
    } catch (error) {
      console.error('Error fetching data:', error);
      domainsDetails.value = {}; // Set to an empty object to prevent issues
    }
  }
}

onMounted(() => {
  fetchData();
});

watch(() => route.params.name, () => {
  fetchData();
}, { immediate: true });

const viewDefault = () => {
	console.log('show default home page');
}

const dummyClick = () => {
	console.log('dummyClick');
}

const navItems = ref<NavItemI[]>([
	{
		label: 'All',
		icon: 'list',
		action: viewDefault
	},
	{
		label: 'Combine Datasets',
		icon: 'chrome',
		action: dummyClick
	},
	{
		label: 'Recently Viewed',
		icon: 'clock',
		action: dummyClick
	},
	{
		label: 'Highlighted',
		icon: 'favourite',
		action: dummyClick
	},
	{
		label: 'Your Catalog',
		icon: 'loading',
		action: dummyClick
	}
]);


const BannerCta = ref<sliderItemI[]>([
	{
		id: 1,
		title: 'Have a question or doubts?',
		text: 'Check our FAQs and Documentation',
		button_text: 'Faqs and Documentation',
		button_link: 'https://www.google.com',
		media_type: 1,
		media_url: slide1,
		template: 1,
	}
])

const showCreateDomainModal = ref(false);
const showDeleteDomainModal = ref(false);
const close = () => {
    showCreateDomainModal.value = false;
};

const openEditModal = () => {
	showCreateDomainModal.value = true;
}

const deleteDomain = () => {
	showDeleteDomainModal.value = true;
}

const closeDelete = () => {
    showDeleteDomainModal.value = false;
};


</script>